import os
os.system('clear') # on linux / os x

import numpy as np
import matplotlib.pyplot as plt

from test_fft.register_addresses_fft_test import *
from test_fft.fft_test_functions import *

print_custom( '*' )
print_custom( '*' )
print_custom( '*' )
print_custom( '*' )
print_custom( '*' )

######################
# GET DATA FROM RECORD
#storageDirectory = '/home/paul/data/2014_06_24/'
#day = '2014_6_24-'
#hour = '9_0_3'
#suffix = '.data'

#typeOfData = '_SBM1_CWF_'
#cwf_f1 = np.genfromtxt( storageDirectory + day + hour + typeOfData + 'F1' + suffix,
#	skip_header = 1)
cwf_f1 = np.zeros( 1000 )

#################
# BUILD WAVEFORMS
nbSamples = 256
nbComponentsPerMatrix = 25
nbFrequencyBins = 128
#wfrm0 = getWaveFromRecord( cwf_f1, nbSamples, 0, columnV )
#wfrm1 = getWaveFromRecord( cwf_f1, nbSamples, 0, columnE1 )
#wfrm2 = getWaveFromRecord( cwf_f1, nbSamples, 0, columnE2 )
#wfrm3 = getWaveFromRecord( cwf_f1, nbSamples, 0, columnB1 )
#wfrm4 = getWaveFromRecord( cwf_f1, nbSamples, 0, columnB2 )
wfrm0 = sineWave( 256, 10, 1000 )
wfrm1 = sineWave( 256, 20, 1000 )
wfrm2 = sineWave( 256, 30, 1000 )
wfrm3 = sineWave( 256, 40, 1000 )
wfrm4 = sineWave( 256, 50, 1000 )

################
# BUILD THE DATA
dataToWrite0 = generateDataToWrite( nbSamples, wfrm0, wfrm1 )
dataToWrite1 = generateDataToWrite( nbSamples, wfrm2, wfrm3 )
dataToWrite2 = generateDataToWrite( nbSamples, wfrm4, np.zeros( nbSamples ) )

########################
# WRITE WAVEFORM IN FIFO
print_custom( "1) write waveforms in FIFOs: " + str(len(dataToWrite0)) + " samples" )
print_reg_sm( )

for k in range(nbSamples):
	RMAPPlugin0.Write( address_FIFO_F2_1_0, [dataToWrite0[k]] )
	RMAPPlugin0.Write( address_FIFO_F2_3_2, [dataToWrite1[k]] )
	RMAPPlugin0.Write( address_FIFO_F2_4,   [dataToWrite2[k]] )
	# write only the FIFO F2
	RMAPPlugin0.Write( address_FIFO_F2_WEN, [0xffffffe0]      )

print_custom( "1) data written in FIFOs" )

print_reg_sm( )

# wait for SM_OUT_Full
while ( is_MEM_OUT_SM_Full() ) == 0:
	print_custom( "SM not full" )

print_reg_sm( )

################
# SM FIRST READ
print_custom( "======= SM FIRST READ" )

components = []

if is_MEM_OUT_SM_Full_FIFO_0():
	print_custom( "FIFO_0 is full" )
	address_MEM_OUT_SM = address_MEM_OUT_SM_0
elif is_MEM_OUT_SM_Full_FIFO_1():
	print_custom( "FIFO_1 is full")
	address_MEM_OUT_SM = address_MEM_OUT_SM_1
else:
	print_custom( "/!\ no MEM_OUT_SM FIFO full /!\ " )

for component in range(nbComponentsPerMatrix):
	print_custom( "component = " + str( component ) )
	currentComp = np.zeros( nbFrequencyBins )
	for frequencyBin in range(nbFrequencyBins):
		# read enable  => 0000 0000 0000 0000
		if is_MEM_OUT_SM_Empty( ) == 1:
			print_custom( "component = " + str( component ) \
							+ " bin = " + str( frequencyBin ) )
		val = RMAPPlugin0.Read( address_MEM_OUT_SM, 1)
		RMAPPlugin0.Write( address_CTRL_SM, [0x00000000] )
		currentComp[frequencyBin] = val[0]
		RMAPPlugin0.ProcessPendingEvents()
	components.append( currentComp )

# PLOT SM

plt.figure( 1 )
plt.subplot(231)
plt.plot(wfrm0, 'b')
plt.subplot(232)
plt.plot(wfrm1, 'g')
plt.plot(wfrm1, '.')
plt.subplot(233)
plt.plot(wfrm2, 'r')
plt.plot(wfrm2, '.')
plt.subplot(234)
plt.plot(wfrm3, 'c')
plt.subplot(235)
plt.plot(wfrm4, 'm')

plt.figure( 2 )
plt.subplot(231)
plt.plot(components[0][:])
plt.plot(components[1][:])
plt.plot(components[2][:])
plt.plot(components[3][:])
plt.subplot(232)
plt.plot(components[4][:])
plt.plot(components[5][:])
plt.plot(components[6][:])
plt.plot(components[7][:])
plt.subplot(233)
plt.plot(components[8][:])
plt.plot(components[9][:])
plt.plot(components[10][:])
plt.plot(components[11][:])
plt.subplot(234)
plt.plot(components[12][:])
plt.plot(components[13][:])
plt.plot(components[14][:])
plt.plot(components[15][:])
plt.subplot(235)
plt.plot(components[16][:])
plt.plot(components[17][:])
plt.plot(components[18][:])
plt.plot(components[19][:])
plt.subplot(236)
plt.plot(components[20][:])
plt.plot(components[21][:])
plt.plot(components[22][:])
plt.plot(components[23][:])
plt.plot(components[24][:])

plt.show()